<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthorityElement StructType
 * @subpackage Structs
 */
class AuthorityElement extends AbstractStructBase
{
    /**
     * The DebugMode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $DebugMode;
    /**
     * The Org
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Org;
    /**
     * The User
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The Language
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Language;
    /**
     * The Currency
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Currency;
    /**
     * The TestMode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $TestMode;
    /**
     * The Version
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Version;
    /**
     * The Timeout
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Timeout;
    /**
     * The IsCacheWarmingRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $IsCacheWarmingRequest;
    /**
     * Constructor method for AuthorityElement
     * @uses AuthorityElement::setDebugMode()
     * @uses AuthorityElement::setOrg()
     * @uses AuthorityElement::setUser()
     * @uses AuthorityElement::setPassword()
     * @uses AuthorityElement::setLanguage()
     * @uses AuthorityElement::setCurrency()
     * @uses AuthorityElement::setTestMode()
     * @uses AuthorityElement::setVersion()
     * @uses AuthorityElement::setTimeout()
     * @uses AuthorityElement::setIsCacheWarmingRequest()
     * @param bool $debugMode
     * @param string $org
     * @param string $user
     * @param string $password
     * @param string $language
     * @param string $currency
     * @param bool $testMode
     * @param string $version
     * @param int $timeout
     * @param bool $isCacheWarmingRequest
     */
    public function __construct($debugMode = null, $org = null, $user = null, $password = null, $language = null, $currency = null, $testMode = null, $version = null, $timeout = null, $isCacheWarmingRequest = null)
    {
        $this
            ->setDebugMode($debugMode)
            ->setOrg($org)
            ->setUser($user)
            ->setPassword($password)
            ->setLanguage($language)
            ->setCurrency($currency)
            ->setTestMode($testMode)
            ->setVersion($version)
            ->setTimeout($timeout)
            ->setIsCacheWarmingRequest($isCacheWarmingRequest);
    }
    /**
     * Get DebugMode value
     * @return bool
     */
    public function getDebugMode()
    {
        return $this->DebugMode;
    }
    /**
     * Set DebugMode value
     * @param bool $debugMode
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setDebugMode($debugMode = null)
    {
        $this->DebugMode = $debugMode;
        return $this;
    }
    /**
     * Get Org value
     * @return string|null
     */
    public function getOrg()
    {
        return $this->Org;
    }
    /**
     * Set Org value
     * @param string $org
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setOrg($org = null)
    {
        $this->Org = $org;
        return $this;
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setUser($user = null)
    {
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setPassword($password = null)
    {
        $this->Password = $password;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setLanguage($language = null)
    {
        $this->Language = $language;
        return $this;
    }
    /**
     * Get Currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->Currency;
    }
    /**
     * Set Currency value
     * @param string $currency
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setCurrency($currency = null)
    {
        $this->Currency = $currency;
        return $this;
    }
    /**
     * Get TestMode value
     * @return bool|null
     */
    public function getTestMode()
    {
        return $this->TestMode;
    }
    /**
     * Set TestMode value
     * @param bool $testMode
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setTestMode($testMode = null)
    {
        $this->TestMode = $testMode;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setVersion($version = null)
    {
        $this->Version = $version;
        return $this;
    }
    /**
     * Get Timeout value
     * @return int|null
     */
    public function getTimeout()
    {
        return $this->Timeout;
    }
    /**
     * Set Timeout value
     * @param int $timeout
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setTimeout($timeout = null)
    {
        $this->Timeout = $timeout;
        return $this;
    }
    /**
     * Get IsCacheWarmingRequest value
     * @return bool|null
     */
    public function getIsCacheWarmingRequest()
    {
        return $this->IsCacheWarmingRequest;
    }
    /**
     * Set IsCacheWarmingRequest value
     * @param bool $isCacheWarmingRequest
     * @return \Stuba\StructType\AuthorityElement
     */
    public function setIsCacheWarmingRequest($isCacheWarmingRequest = null)
    {
        $this->IsCacheWarmingRequest = $isCacheWarmingRequest;
        return $this;
    }
}
