<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookingCancel StructType
 * @subpackage Structs
 */
class BookingCancel extends AbstractStructBase
{
    /**
     * The xiRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Stuba\StructType\BookingCancel
     */
    public $xiRequest;
    /**
     * The Authority
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Stuba\StructType\AuthorityElement
     */
    public $Authority;
    /**
     * The BookingId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $BookingId;
    /**
     * The CommitLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CommitLevel;
    /**
     * The DetailLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DetailLevel;
    /**
     * Constructor method for BookingCancel
     * @uses BookingCancel::setXiRequest()
     * @uses BookingCancel::setAuthority()
     * @uses BookingCancel::setBookingId()
     * @uses BookingCancel::setCommitLevel()
     * @uses BookingCancel::setDetailLevel()
     * @param \Stuba\StructType\BookingCancel $xiRequest
     * @param \Stuba\StructType\AuthorityElement $authority
     * @param int $bookingId
     * @param string $commitLevel
     * @param string $detailLevel
     */
    public function __construct(\Stuba\StructType\BookingCancel $xiRequest = null, \Stuba\StructType\AuthorityElement $authority = null, $bookingId = null, $commitLevel = null, $detailLevel = null)
    {
        $this
            ->setXiRequest($xiRequest)
            ->setAuthority($authority)
            ->setBookingId($bookingId)
            ->setCommitLevel($commitLevel)
            ->setDetailLevel($detailLevel);
    }
    /**
     * Get xiRequest value
     * @return \Stuba\StructType\BookingCancel|null
     */
    public function getXiRequest()
    {
        return $this->xiRequest;
    }
    /**
     * Set xiRequest value
     * @param \Stuba\StructType\BookingCancel $xiRequest
     * @return \Stuba\StructType\BookingCancel
     */
    public function setXiRequest(\Stuba\StructType\BookingCancel $xiRequest = null)
    {
        $this->xiRequest = $xiRequest;
        return $this;
    }
    /**
     * Get Authority value
     * @return \Stuba\StructType\AuthorityElement|null
     */
    public function getAuthority()
    {
        return $this->Authority;
    }
    /**
     * Set Authority value
     * @param \Stuba\StructType\AuthorityElement $authority
     * @return \Stuba\StructType\BookingCancel
     */
    public function setAuthority(\Stuba\StructType\AuthorityElement $authority = null)
    {
        $this->Authority = $authority;
        return $this;
    }
    /**
     * Get BookingId value
     * @return int|null
     */
    public function getBookingId()
    {
        return $this->BookingId;
    }
    /**
     * Set BookingId value
     * @param int $bookingId
     * @return \Stuba\StructType\BookingCancel
     */
    public function setBookingId($bookingId = null)
    {
        $this->BookingId = $bookingId;
        return $this;
    }
    /**
     * Get CommitLevel value
     * @return string|null
     */
    public function getCommitLevel()
    {
        return $this->CommitLevel;
    }
    /**
     * Set CommitLevel value
     * @param string $commitLevel
     * @return \Stuba\StructType\BookingCancel
     */
    public function setCommitLevel($commitLevel = null)
    {
        $this->CommitLevel = $commitLevel;
        return $this;
    }
    /**
     * Get DetailLevel value
     * @return string|null
     */
    public function getDetailLevel()
    {
        return $this->DetailLevel;
    }
    /**
     * Set DetailLevel value
     * @param string $detailLevel
     * @return \Stuba\StructType\BookingCancel
     */
    public function setDetailLevel($detailLevel = null)
    {
        $this->DetailLevel = $detailLevel;
        return $this;
    }
}
