<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerElement StructType
 * @subpackage Structs
 */
class CustomerElement extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The OptIn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $OptIn;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Title;
    /**
     * The Forename
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Forename;
    /**
     * The MiddleInitials
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MiddleInitials;
    /**
     * The Surname
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Surname;
    /**
     * The Address1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address1;
    /**
     * The Address2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address2;
    /**
     * The Address3
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address3;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $City;
    /**
     * The State
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $State;
    /**
     * The Zip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Zip;
    /**
     * The Country
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Country;
    /**
     * The Tel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tel;
    /**
     * The Fax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Fax;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * Constructor method for CustomerElement
     * @uses CustomerElement::setId()
     * @uses CustomerElement::setOptIn()
     * @uses CustomerElement::setTitle()
     * @uses CustomerElement::setForename()
     * @uses CustomerElement::setMiddleInitials()
     * @uses CustomerElement::setSurname()
     * @uses CustomerElement::setAddress1()
     * @uses CustomerElement::setAddress2()
     * @uses CustomerElement::setAddress3()
     * @uses CustomerElement::setCity()
     * @uses CustomerElement::setState()
     * @uses CustomerElement::setZip()
     * @uses CustomerElement::setCountry()
     * @uses CustomerElement::setTel()
     * @uses CustomerElement::setFax()
     * @uses CustomerElement::setEmail()
     * @param int $id
     * @param bool $optIn
     * @param string $title
     * @param string $forename
     * @param string $middleInitials
     * @param string $surname
     * @param string $address1
     * @param string $address2
     * @param string $address3
     * @param string $city
     * @param string $state
     * @param string $zip
     * @param string $country
     * @param string $tel
     * @param string $fax
     * @param string $email
     */
    public function __construct($id = null, $optIn = null, $title = null, $forename = null, $middleInitials = null, $surname = null, $address1 = null, $address2 = null, $address3 = null, $city = null, $state = null, $zip = null, $country = null, $tel = null, $fax = null, $email = null)
    {
        $this
            ->setId($id)
            ->setOptIn($optIn)
            ->setTitle($title)
            ->setForename($forename)
            ->setMiddleInitials($middleInitials)
            ->setSurname($surname)
            ->setAddress1($address1)
            ->setAddress2($address2)
            ->setAddress3($address3)
            ->setCity($city)
            ->setState($state)
            ->setZip($zip)
            ->setCountry($country)
            ->setTel($tel)
            ->setFax($fax)
            ->setEmail($email);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \Stuba\StructType\CustomerElement
     */
    public function setId($id = null)
    {
        $this->Id = $id;
        return $this;
    }
    /**
     * Get OptIn value
     * @return bool
     */
    public function getOptIn()
    {
        return $this->OptIn;
    }
    /**
     * Set OptIn value
     * @param bool $optIn
     * @return \Stuba\StructType\CustomerElement
     */
    public function setOptIn($optIn = null)
    {
        $this->OptIn = $optIn;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \Stuba\StructType\CustomerElement
     */
    public function setTitle($title = null)
    {
        $this->Title = $title;
        return $this;
    }
    /**
     * Get Forename value
     * @return string|null
     */
    public function getForename()
    {
        return $this->Forename;
    }
    /**
     * Set Forename value
     * @param string $forename
     * @return \Stuba\StructType\CustomerElement
     */
    public function setForename($forename = null)
    {
        $this->Forename = $forename;
        return $this;
    }
    /**
     * Get MiddleInitials value
     * @return string|null
     */
    public function getMiddleInitials()
    {
        return $this->MiddleInitials;
    }
    /**
     * Set MiddleInitials value
     * @param string $middleInitials
     * @return \Stuba\StructType\CustomerElement
     */
    public function setMiddleInitials($middleInitials = null)
    {
        $this->MiddleInitials = $middleInitials;
        return $this;
    }
    /**
     * Get Surname value
     * @return string|null
     */
    public function getSurname()
    {
        return $this->Surname;
    }
    /**
     * Set Surname value
     * @param string $surname
     * @return \Stuba\StructType\CustomerElement
     */
    public function setSurname($surname = null)
    {
        $this->Surname = $surname;
        return $this;
    }
    /**
     * Get Address1 value
     * @return string|null
     */
    public function getAddress1()
    {
        return $this->Address1;
    }
    /**
     * Set Address1 value
     * @param string $address1
     * @return \Stuba\StructType\CustomerElement
     */
    public function setAddress1($address1 = null)
    {
        $this->Address1 = $address1;
        return $this;
    }
    /**
     * Get Address2 value
     * @return string|null
     */
    public function getAddress2()
    {
        return $this->Address2;
    }
    /**
     * Set Address2 value
     * @param string $address2
     * @return \Stuba\StructType\CustomerElement
     */
    public function setAddress2($address2 = null)
    {
        $this->Address2 = $address2;
        return $this;
    }
    /**
     * Get Address3 value
     * @return string|null
     */
    public function getAddress3()
    {
        return $this->Address3;
    }
    /**
     * Set Address3 value
     * @param string $address3
     * @return \Stuba\StructType\CustomerElement
     */
    public function setAddress3($address3 = null)
    {
        $this->Address3 = $address3;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \Stuba\StructType\CustomerElement
     */
    public function setCity($city = null)
    {
        $this->City = $city;
        return $this;
    }
    /**
     * Get State value
     * @return string|null
     */
    public function getState()
    {
        return $this->State;
    }
    /**
     * Set State value
     * @param string $state
     * @return \Stuba\StructType\CustomerElement
     */
    public function setState($state = null)
    {
        $this->State = $state;
        return $this;
    }
    /**
     * Get Zip value
     * @return string|null
     */
    public function getZip()
    {
        return $this->Zip;
    }
    /**
     * Set Zip value
     * @param string $zip
     * @return \Stuba\StructType\CustomerElement
     */
    public function setZip($zip = null)
    {
        $this->Zip = $zip;
        return $this;
    }
    /**
     * Get Country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->Country;
    }
    /**
     * Set Country value
     * @param string $country
     * @return \Stuba\StructType\CustomerElement
     */
    public function setCountry($country = null)
    {
        $this->Country = $country;
        return $this;
    }
    /**
     * Get Tel value
     * @return string|null
     */
    public function getTel()
    {
        return $this->Tel;
    }
    /**
     * Set Tel value
     * @param string $tel
     * @return \Stuba\StructType\CustomerElement
     */
    public function setTel($tel = null)
    {
        $this->Tel = $tel;
        return $this;
    }
    /**
     * Get Fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * Set Fax value
     * @param string $fax
     * @return \Stuba\StructType\CustomerElement
     */
    public function setFax($fax = null)
    {
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \Stuba\StructType\CustomerElement
     */
    public function setEmail($email = null)
    {
        $this->Email = $email;
        return $this;
    }
}
