<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditGuestElement StructType
 * @subpackage Structs
 */
abstract class EditGuestElement extends AbstractStructBase
{
    /**
     * The Action
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Action;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The OldName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OldName;
    /**
     * The NewName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NewName;
    /**
     * Constructor method for EditGuestElement
     * @uses EditGuestElement::setAction()
     * @uses EditGuestElement::setId()
     * @uses EditGuestElement::setOldName()
     * @uses EditGuestElement::setNewName()
     * @param string $action
     * @param int $id
     * @param string $oldName
     * @param string $newName
     */
    public function __construct($action = null, $id = null, $oldName = null, $newName = null)
    {
        $this
            ->setAction($action)
            ->setId($id)
            ->setOldName($oldName)
            ->setNewName($newName);
    }
    /**
     * Get Action value
     * @return string
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param string $action
     * @return \Stuba\StructType\EditGuestElement
     */
    public function setAction($action = null)
    {
        $this->Action = $action;
        return $this;
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \Stuba\StructType\EditGuestElement
     */
    public function setId($id = null)
    {
        $this->Id = $id;
        return $this;
    }
    /**
     * Get OldName value
     * @return string|null
     */
    public function getOldName()
    {
        return $this->OldName;
    }
    /**
     * Set OldName value
     * @param string $oldName
     * @return \Stuba\StructType\EditGuestElement
     */
    public function setOldName($oldName = null)
    {
        $this->OldName = $oldName;
        return $this;
    }
    /**
     * Get NewName value
     * @return string|null
     */
    public function getNewName()
    {
        return $this->NewName;
    }
    /**
     * Set NewName value
     * @param string $newName
     * @return \Stuba\StructType\EditGuestElement
     */
    public function setNewName($newName = null)
    {
        $this->NewName = $newName;
        return $this;
    }
}
