<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelDetailsElement StructType
 * @subpackage Structs
 */
class HotelDetailsElement extends AbstractStructBase
{
    /**
     * The BuyingCancelPolicy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Stuba\StructType\CancelPolicyElement[]
     */
    public $BuyingCancelPolicy;
    /**
     * The SellingCancelPolicy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Stuba\StructType\CancelPolicyElement[]
     */
    public $SellingCancelPolicy;
    /**
     * Constructor method for HotelDetailsElement
     * @uses HotelDetailsElement::setBuyingCancelPolicy()
     * @uses HotelDetailsElement::setSellingCancelPolicy()
     * @param \Stuba\StructType\CancelPolicyElement[] $buyingCancelPolicy
     * @param \Stuba\StructType\CancelPolicyElement[] $sellingCancelPolicy
     */
    public function __construct(array $buyingCancelPolicy = array(), array $sellingCancelPolicy = array())
    {
        $this
            ->setBuyingCancelPolicy($buyingCancelPolicy)
            ->setSellingCancelPolicy($sellingCancelPolicy);
    }
    /**
     * Get BuyingCancelPolicy value
     * @return \Stuba\StructType\CancelPolicyElement[]|null
     */
    public function getBuyingCancelPolicy()
    {
        return $this->BuyingCancelPolicy;
    }
    /**
     * Set BuyingCancelPolicy value
     * @param \Stuba\StructType\CancelPolicyElement[] $buyingCancelPolicy
     * @return \Stuba\StructType\HotelDetailsElement
     */
    public function setBuyingCancelPolicy(array $buyingCancelPolicy = array())
    {
        $this->BuyingCancelPolicy = $buyingCancelPolicy;
        return $this;
    }
    /**
     * Add item to BuyingCancelPolicy value
     * @throws \InvalidArgumentException
     * @param \Stuba\StructType\CancelPolicyElement $item
     * @return \Stuba\StructType\HotelDetailsElement
     */
    public function addToBuyingCancelPolicy(\Stuba\StructType\CancelPolicyElement $item)
    {
        $this->BuyingCancelPolicy[] = $item;
        return $this;
    }
    /**
     * Get SellingCancelPolicy value
     * @return \Stuba\StructType\CancelPolicyElement[]|null
     */
    public function getSellingCancelPolicy()
    {
        return $this->SellingCancelPolicy;
    }
    /**
     * Set SellingCancelPolicy value
     * @param \Stuba\StructType\CancelPolicyElement[] $sellingCancelPolicy
     * @return \Stuba\StructType\HotelDetailsElement
     */
    public function setSellingCancelPolicy(array $sellingCancelPolicy = array())
    {
        $this->SellingCancelPolicy = $sellingCancelPolicy;
        return $this;
    }
    /**
     * Add item to SellingCancelPolicy value
     * @throws \InvalidArgumentException
     * @param \Stuba\StructType\CancelPolicyElement $item
     * @return \Stuba\StructType\HotelDetailsElement
     */
    public function addToSellingCancelPolicy(\Stuba\StructType\CancelPolicyElement $item)
    {
        $this->SellingCancelPolicy[] = $item;
        return $this;
    }
}
