<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegionSearchResult StructType
 * @subpackage Structs
 */
class RegionSearchResult extends AbstractStructBase
{
    /**
     * The Region
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Stuba\StructType\RegionElement[]
     */
    public $Region;
    /**
     * Constructor method for RegionSearchResult
     * @uses RegionSearchResult::setRegion()
     * @param \Stuba\StructType\RegionElement[] $region
     */
    public function __construct(array $region = array())
    {
        $this
            ->setRegion($region);
    }
    /**
     * Get Region value
     * @return \Stuba\StructType\RegionElement[]|null
     */
    public function getRegion()
    {
        return $this->Region;
    }
    /**
     * Set Region value
     * @param \Stuba\StructType\RegionElement[] $region
     * @return \Stuba\StructType\RegionSearchResult
     */
    public function setRegion(array $region = array())
    {
        $this->Region = $region;
        return $this;
    }
    /**
     * Add item to Region value
     * @throws \InvalidArgumentException
     * @param \Stuba\StructType\RegionElement $item
     * @return \Stuba\StructType\RegionSearchResult
     */
    public function addToRegion(\Stuba\StructType\RegionElement $item)
    {
        $this->Region[] = $item;
        return $this;
    }
}
