<?php

namespace Stuba\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpgradeElement StructType
 * @subpackage Structs
 */
class UpgradeElement extends AbstractStructBase
{
    /**
     * The Price
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Stuba\StructType\MoneyElement
     */
    public $Price;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The SellingPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Stuba\StructType\MoneyElement
     */
    public $SellingPrice;
    /**
     * The PerNight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $PerNight;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The perNight
     * @var bool
     */
    public $perNight;
    /**
     * Constructor method for UpgradeElement
     * @uses UpgradeElement::setPrice()
     * @uses UpgradeElement::setName()
     * @uses UpgradeElement::setDescription()
     * @uses UpgradeElement::setType()
     * @uses UpgradeElement::setSellingPrice()
     * @uses UpgradeElement::setPerNight()
     * @uses UpgradeElement::setName_1()
     * @uses UpgradeElement::setDescription_1()
     * @uses UpgradeElement::setType_1()
     * @uses UpgradeElement::setPerNight_1()
     * @param \Stuba\StructType\MoneyElement $price
     * @param string $name
     * @param string $description
     * @param string $type
     * @param \Stuba\StructType\MoneyElement $sellingPrice
     * @param bool $perNight
     * @param string $name
     * @param string $description
     * @param string $type
     * @param bool $perNight
     */
    public function __construct(\Stuba\StructType\MoneyElement $price = null, $name = null, $description = null, $type = null, \Stuba\StructType\MoneyElement $sellingPrice = null, $perNight = null, $name_1 = null, $description_1 = null, $type_1 = null, $perNight_1 = null)
    {
        $this
            ->setPrice($price)
            ->setName($name)
            ->setDescription($description)
            ->setType($type)
            ->setSellingPrice($sellingPrice)
            ->setPerNight($perNight)
            ->setName_1($name_1)
            ->setDescription_1($description_1)
            ->setType_1($type_1)
            ->setPerNight_1($perNight_1);
    }
    /**
     * Get Price value
     * @return \Stuba\StructType\MoneyElement|null
     */
    public function getPrice()
    {
        return $this->Price;
    }
    /**
     * Set Price value
     * @param \Stuba\StructType\MoneyElement $price
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setPrice(\Stuba\StructType\MoneyElement $price = null)
    {
        $this->Price = $price;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setName($name = null)
    {
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setDescription($description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setType($type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get SellingPrice value
     * @return \Stuba\StructType\MoneyElement|null
     */
    public function getSellingPrice()
    {
        return $this->SellingPrice;
    }
    /**
     * Set SellingPrice value
     * @param \Stuba\StructType\MoneyElement $sellingPrice
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setSellingPrice(\Stuba\StructType\MoneyElement $sellingPrice = null)
    {
        $this->SellingPrice = $sellingPrice;
        return $this;
    }
    /**
     * Get PerNight value
     * @return bool|null
     */
    public function getPerNight()
    {
        return $this->PerNight;
    }
    /**
     * Set PerNight value
     * @param bool $perNight
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setPerNight($perNight = null)
    {
        $this->PerNight = $perNight;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName_1()
    {
        return $this->name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setName_1($name_1 = null)
    {
        $this->name = $name_1;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription_1()
    {
        return $this->description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setDescription_1($description_1 = null)
    {
        $this->description = $description_1;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType_1()
    {
        return $this->type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setType_1($type_1 = null)
    {
        $this->type = $type_1;
        return $this;
    }
    /**
     * Get PerNight value
     * @return bool|null
     */
    public function getPerNight_1()
    {
        return $this->perNight;
    }
    /**
     * Set PerNight value
     * @param bool $perNight
     * @return \Stuba\StructType\UpgradeElement
     */
    public function setPerNight_1($perNight_1 = null)
    {
        $this->perNight = $perNight_1;
        return $this;
    }
}
